/* eslint-disable quotes */
import { systemList } from "./system";
// import { DwHttpApiInterceptor } from "@webdpt/framework/http";
/* eslint-disable quotes */
import { Component, OnInit } from "@angular/core";
import {
  DigiMiddlewareAuthApp,
  DigiMiddlewareAuthUser,
} from "app/config/app-auth-token";
import { CommonService } from "../service/common.service";
@Component({
  selector: "app-layout",
  templateUrl: "./layout.component.html",
  styleUrls: ["./layout.component.less"],
})
export class LayoutComponent implements OnInit {
  // 登出： https://iam-test.digiwincloud.com.cn/api/iam/v2/identity/logout
  userToken: string;
  systemList = {};
  user_info = {
    userId: "", // 当前用户账号
    tenantId: "", // 当前用户租户id
    productKey: "", // json字段的头部
  };
  queryDisplayList = [];
  constructor(private commonService: CommonService) {}
  ngOnInit(): void {
    this.systemList = systemList;
    this.getSystem();
  }
  toLinkSystem(type?) {
    // 1. 通过获取user_token获取单点登录链接
    // 请求获取user_token
    switch (type) {
      case "DMP":
        this.getUserToken(type, this.systemList["DMP"]);
        break;
      case "chatFile":
        this.getUserToken(type, this.systemList["chatFile"]);
        break;
      case "KMO":
        this.getUserToken(type, this.systemList["KMO"]);
        break;
      case "EIP":
        this.getUserToken(type, this.systemList["EIP"]);
        break;
      case "AIOT":
        this.getUserToken(type, this.systemList["AIOT"]);
        break;
      case "equipmentCloud":
        this.getUserToken(type, this.systemList["equipmentCloud"]);
        break;
      case "partsCloud":
        this.getUserToken(type, this.systemList["partsCloud"]);
        break;
      case "E10229":
        this.getUserToken(type, this.systemList["E10229"]);
        break;
      case "T100bs":
        this.getUserToken(type, this.systemList["T100bs"]);
        break;
    }
  }
  /**
   * 通过请求queryDisplayList接口登录
   */
  getSystem() {
    const headers = {
      "Digi-Middleware-Auth-App": DigiMiddlewareAuthApp,
      "Digi-Middleware-Auth-User": DigiMiddlewareAuthUser,
    };
    this.commonService
      .getRequestWithHeaders(
        this.commonService.semcUrl + "/tenant/semc/applink/queryDisplayList",
        headers
      )
      .then((res) => {
        this.queryDisplayList = res.response;
        console.log("queryDisplayList", this.queryDisplayList);
      })
      .catch((error) => console.error(error));
  }
  /**
   * 三种方式的url拼接
   */
  async getUserToken(type, item) {
    console.log("item", item);
    if (item.ssoLogin) {
      // 单点登录跳转 queryDisplayList接口的数据 底部 e10 t100
      // 需要拼applicationAppId
      console.log("单点登录跳转的方式", type);
      let url = "";
      const queryDisplayList = this.queryDisplayList.filter((arr) => {
        return arr.code === type;
      });
      // console.log("queryDisplayList111", queryDisplayList);
      if (
        queryDisplayList.length > 0 &&
        queryDisplayList[0]?.applicationAppId
      ) {
        url =
          queryDisplayList[0]["cloudwebsite"] +
          "&code=" +
          queryDisplayList[0].applicationAppId;
      } else {
        url = queryDisplayList[0]["cloudwebsite"];
      }
      console.log("单点登录url", url);
      window.open(url);
    } else if (item.mockLogin) {
      console.log("模拟登录的方式", type);
      // 通过书康哥接口请求 模拟登录
      const DwUserInfo = JSON.parse(sessionStorage.getItem("DwUserInfo"));
      console.log("DwUserInfo", DwUserInfo);
      this.user_info.userId = DwUserInfo["userId"];
      this.user_info.tenantId = DwUserInfo["tenantId"];
      this.user_info.productKey = type;
      console.log("user_info", this.user_info);
      let getUrl = "";
      getUrl =
        this.commonService.apiUrl + "/restful/standard/demo/api/default/login";
      this.commonService
        .postWithHeaders(getUrl, this.user_info, {})
        .then((res) => {
          // console.log("res", res);
          if (res && res.response) {
            this.userToken = res.response.user_token;
            const url = item.url + "/sso-login?userToken=" + this.userToken;
            window.open(url);
          }
        });
    } else {
      console.log("切换租户的方式", type);
      // 接口 refresh/tenant 切换租户方式
      const getUrl =
        this.commonService.iamUrl + "/api/iam/v2/identity/token/refresh/tenant";
      console.log("iamUrl", this.commonService.iamUrl);
      const headers = {
        "Digi-Middleware-Auth-App": DigiMiddlewareAuthApp,
        "Digi-Middleware-Auth-User": DigiMiddlewareAuthUser,
      };
      const data = {
        tenantSid: item.sid,
      };
      this.userToken = await this.commonService
        .postWithHeaders(getUrl, data, headers)
        .then((res) => {
          // console.log("res", res);
          return res.user_token;
        });
      let url = "";
      url = item.url + "/sso-login?userToken=" + this.userToken;
      console.log("切换租户的方式url", url);
      window.open(url);
    }
  }
}
